---
title: 2D collision detection
slug: Games/Techniques/2D_collision_detection
tags:
  - 2D
  - Games
  - JavaScript
  - collision detection
---
<div>{{GamesSidebar}}</div>

<div class="summary">
<p>Algorithms to detect collision in 2D games depend on the type of shapes that can collide (e.g. Rectangle to Rectangle, Rectangle to Circle, Circle to Circle). Generally you will have a simple generic shape that covers the entity known as a "hitbox" so even though collision may not be pixel perfect, it will look good enough and be performant across multiple entities. This article provides a review of the most common techniques used to provide collision detection in 2D games.</p>
</div>

<h2 id="Axis-Aligned_Bounding_Box">Axis-Aligned Bounding Box</h2>

<p>One of the simpler forms of collision detection is between two rectangles that are axis aligned — meaning no rotation. The algorithm works by ensuring there is no gap between any of the 4 sides of the rectangles. Any gap means a collision does not exist.</p>

<pre class="brush: js notranslate">var rect1 = {x: 5, y: 5, width: 50, height: 50}
var rect2 = {x: 20, y: 10, width: 10, height: 10}

if (rect1.x &lt; rect2.x + rect2.width &amp;&amp;
   rect1.x + rect1.width &gt; rect2.x &amp;&amp;
   rect1.y &lt; rect2.y + rect2.height &amp;&amp;
   rect1.y + rect1.height &gt; rect2.y) {
    // collision detected!
}

// filling in the values =&gt;

if (5 &lt; 30 &amp;&amp;
    55 &gt; 20 &amp;&amp;
    5 &lt; 20 &amp;&amp;
    55 &gt; 10) {
    // collision detected!
}
</pre>

<div class="hidden">
<h5 id="Rect_code">Rect code</h5>

<pre class="brush: html notranslate">&lt;div id="cr-stage"&gt;&lt;/div&gt;
&lt;p&gt;Move the rectangle with arrow keys. Green means collision, blue means no collision.&lt;/p&gt;
&lt;script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/crafty/0.5.4/crafty-min.js"&gt;&lt;/script&gt;
</pre>

<pre class="brush: js notranslate">Crafty.init(200, 200);

var dim1 = {x: 5, y: 5, w: 50, h: 50}
var dim2 = {x: 20, y: 10, w: 60, h: 40}

var rect1 = Crafty.e("2D, Canvas, Color").attr(dim1).color("red");

var rect2 = Crafty.e("2D, Canvas, Color, Keyboard, Fourway").fourway(2).attr(dim2).color("blue");

rect2.bind("EnterFrame", function () {
    if (rect1.x &lt; rect2.x + rect2.w &amp;&amp;
        rect1.x + rect1.w &gt; rect2.x &amp;&amp;
        rect1.y &lt; rect2.y + rect2.h &amp;&amp;
        rect1.h + rect1.y &gt; rect2.y) {
        // collision detected!
        this.color("green");
    } else {
        // no collision
        this.color("blue");
    }
});

</pre>
</div>

<p>{{ EmbedLiveSample('Rect_code', '700', '300', '', 'Games/Techniques/2D_collision_detection') }}</p>

<div class="note">
<p><strong>Note</strong>: <a href="https://jsfiddle.net/jlr7245/217jrozd/3/">Another example without Canvas or external libraries</a>.</p>
</div>

<h2 id="Circle_Collision">Circle Collision</h2>

<p>Another simple shape for collision detection is between two circles. This algorithm works by taking the centre points of the two circles and ensuring the distance between the centre points are less than the two radii added together.</p>

<div class="hidden">
<h6 id="Playable_code">Playable code</h6>

<pre class="brush: html notranslate">&lt;div id="cr-stage"&gt;&lt;/div&gt;
&lt;p&gt;Move the circle with arrow keys. Green means collision, blue means no collision.&lt;/p&gt;
&lt;script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/crafty/0.5.4/crafty-min.js"&gt;&lt;/script&gt;
</pre>

<pre class="brush: css notranslate">#cr-stage {
    position: static !important;
    height: 200px !important;
}
</pre>

<pre class="brush: js notranslate">Crafty.init(200, 200);

var dim1 = {x: 5, y: 5}
var dim2 = {x: 20, y: 20}

Crafty.c("Circle", {
   circle: function(radius, color) {
        this.radius = radius;
        this.w = this.h = radius * 2;
        this.color = color || "#000000";

        this.bind("Move", Crafty.DrawManager.drawAll)
        return this;
   },

   draw: function() {
       var ctx = Crafty.canvas.context;
       ctx.save();
       ctx.fillStyle = this.color;
       ctx.beginPath();
       ctx.arc(
           this.x + this.radius,
           this.y + this.radius,
           this.radius,
           0,
           Math.PI * 2
       );
       ctx.closePath();
       ctx.fill();
       ctx.restore();
    }
});

var circle1 = Crafty.e("2D, Canvas, Circle").attr(dim1).circle(15, "red");

var circle2 = Crafty.e("2D, Canvas, Circle, Fourway").fourway(2).attr(dim2).circle(20, "blue");

circle2.bind("EnterFrame", function () {
    var dx = (circle1.x + circle1.radius) - (circle2.x + circle2.radius);
    var dy = (circle1.y + circle1.radius) - (circle2.y + circle2.radius);
    var distance = Math.sqrt(dx * dx + dy * dy);

    if (distance &lt; circle1.radius + circle2.radius) {
        // collision detected!
        this.color = "green";
    } else {
        // no collision
        this.color = "blue";
    }
});

</pre>
</div>

<pre class="brush: js notranslate"><code>var circle1 = {radius: 20, x: 5, y: 5};
var circle2 = {radius: 12, x: 10, y: 5};

var dx = circle1.x - circle2.x;
var dy = circle1.y - circle2.y;
var distance = Math.sqrt(dx * dx + dy * dy);

if (distance &lt; circle1.radius + circle2.radius) {
    // collision detected!
}</code>
</pre>

<p>{{ EmbedLiveSample('Playable_code', '700', '300', '', 'Games/Techniques/2D_collision_detection') }}</p>

<p><strong>Note</strong>:  <a href="https://jsfiddle.net/jlr7245/teb4znk0/20/">Here is another example without Canvas or external libraries.</a></p>

<h2 id="Separating_Axis_Theorem">Separating Axis Theorem</h2>

<p>This is a collision algorithm that can detect a collision between any two *convex* polygons. It's more complicated to implement than the above methods but is more powerful. The complexity of an algorithm like this means we will need to consider performance optimization, covered in the next section.</p>

<p>Implementing SAT is out of scope for this page so see the recommended tutorials below:</p>

<ol>
 <li><a href="http://www.sevenson.com.au/actionscript/sat/">Separating Axis Theorem (SAT) explanation</a></li>
 <li><a href="http://www.metanetsoftware.com/technique/tutorialA.html">Collision detection and response</a></li>
 <li><a href="http://gamedevelopment.tutsplus.com/tutorials/collision-detection-using-the-separating-axis-theorem--gamedev-169">Collision detection Using the Separating Axis Theorem</a></li>
 <li><a href="http://www.codezealot.org/archives/55">SAT (Separating Axis Theorem)</a></li>
 <li><a href="http://programmerart.weebly.com/separating-axis-theorem.html">Separating Axis Theorem</a></li>
</ol>

<h2 id="Collision_Performance">Collision Performance</h2>

<p>While some of these algorithms for collision detection are simple enough to calculate, it can be a waste of cycles to test *every* entity with every other entity. Usually games will split collision into two phases, broad and narrow.</p>

<h3 id="Broad_Phase">Broad Phase</h3>

<p>Broad phase should give you a list of entities that *could* be colliding. This can be implemented with a spacial data structure that will give you a rough idea of where the entity exists and what exist around it. Some examples of spacial data structures are Quad Trees, R-Trees or a Spacial Hashmap.</p>

<h3 id="Narrow_Phase">Narrow Phase</h3>

<p>When you have a small list of entities to check you will want to use a narrow phase algorithm (like the ones listed above) to provide a certain answer as to whether there is a collision or not.</p>
